/* $Valkyrie: Valkyrie/Valkyrie/ImageFileList.cpp,v 1.10 2004/12/16 12:55:33 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// ImageFileList.cpp: ٹ ̹   Ŭ
//

#include "stdafx.h"
#include <xtrace.h>
#include "imagefilelist.h"

//
// Ϸκ ٹ ε
//
// Ķ
//		filename	[in]	ϸ
//
// ϰ
//		Ϸκ ε ̹ ϸ 
//
UINT CImageFileList::LoadFromFile(LPCTSTR filename)
{
	FILE	*fp = NULL;
	TCHAR	buffer[MAX_PATH];

	fp = fopen(filename, "rt");
	if(fp != NULL)
	{
		m_filelist.clear();
		while(fgets(buffer, sizeof(buffer) - 1, fp) != NULL)
		{
			if(buffer[strlen(buffer)-1] == '\n')
				buffer[strlen(buffer)-1] = '\0';

			if(strcmp(buffer, "") != 0)				
			{
				m_filelist.push_back(string(buffer));
			}
		}

		m_currfile = m_filelist.begin();
		fclose(fp);
	}

	return m_filelist.size();        
}

//
// Ͽ ٹ 
//
// Ķ
//		filename	[in]	ϸ
//
// ϰ
//		 ̹ ϸ 
//
UINT CImageFileList::SaveToFile(LPCTSTR filename)
{
	FILE			*fp;
	StringListIter	pos;

	fp = fopen(filename, "wt");
	if(fp != NULL)
	{
		for(pos=m_filelist.begin(); pos!=m_filelist.end(); ++pos)
		{
			fprintf(fp, "%s\n", (*pos).c_str());
		}

		fclose(fp);
	}

	return m_filelist.size();
}

//
//  ̹ ̵
//
// Ķ 
// ϰ 
//
void CImageFileList::Next()
{
    ++m_currfile;

	if(m_currfile == m_filelist.end())
		m_currfile = m_filelist.begin();
}

//
//  ̹ ̵
//
// Ķ 
// ϰ 
//
void CImageFileList::Prev()
{
	if(m_currfile == m_filelist.begin())
		m_currfile = m_filelist.end();

	--m_currfile;
}

//
//  ̹ ϸ 
//
// Ķ 
//
// ϰ
//		̹ ϸ
//
LPCTSTR CImageFileList::CurrentFileName()
{
	LPCTSTR filename = NULL;

	if(m_currfile != m_filelist.end())
		filename = (*m_currfile).c_str();

	return filename;
}

//
// ̹  ߰
//
// Ķ
//		filename	[in]	ϸ
//
// ϰ 
//
void CImageFileList::AddImage(LPCTSTR filename)
{
	m_filelist.push_back(string(filename));
}

//
// ٹ ̹ ϸ  ϴ Լ
//
// Ķ 
//
// ϰ
//		ٹ ̹ ϸ 
//
size_t CImageFileList::Size()
{
	return m_filelist.size();
}