/* $Valkyrie: Valkyrie/Valkyrie/imgvw_if.cpp,v 1.7 2004/12/16 12:55:33 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// imgvw_if.cpp: ̹  DLL ̽
//

#include "stdafx.h"
#include "imgvw_if.h"
#include "util.h"

//
// DLL  Լ ε   
//
// Ķ
//		x	[in]	 x ǥ
//		y	[in]	 y ǥ
//		w	[in]	  ũ
//		h	[in]	  ũ
//
CImgvwIf::CImgvwIf(HWND hwnd, int x, int y, int w, int h)
{
	m_bOk = GetProcAddresses(	&m_hInst, "imgvw.dll", 4, 
								&m_fnInitialize, "IMGVW_Initialize",
								&m_fnCleanup, "IMGVW_Cleanup",
								&m_fnCreateTrayWnd, "IMGVW_CreateTrayWnd",
								&m_fnSetBitmap, "IMGVW_SetBitmap"			);

    
	if(m_bOk)
	{
		m_fnInitialize();
		m_hTrayWnd = m_fnCreateTrayWnd(hwnd, x, y, w, h);
	}
}

//
//   ı DLL 
//
CImgvwIf::~CImgvwIf()
{
	if(m_bOk)
	{
		if(m_hTrayWnd != NULL)
		{
			ShowWindow(m_hTrayWnd, SW_HIDE);
			BOOL b = DestroyWindow(m_hTrayWnd);
			DWORD dw = GetLastError();
			dw = dw;
			m_hTrayWnd = NULL;
		}

		m_fnCleanup();
		FreeLibrary(m_hInst);
	}
}

//
// Ʈ 
//
// Ķ
//		lpszBmpName	[in]	Ʈ  
//
// ϰ
//		  0,   -1 
//
LONG CImgvwIf::SetBitmap(LPCTSTR lpszBmpName) const
{
	LONG lRet = -1;

	if(IsOk())
		lRet = m_fnSetBitmap(m_hTrayWnd, lpszBmpName);

	return lRet;
}

//
// ʱȭ   ߻ üũ
//
// Ķ 
//
// ϰ
//		 ߻  0,   1 
//
BOOL CImgvwIf::IsOk() const
{
	return m_bOk;
}

//
//    ڵ ȯ
//
// Ķ 
//
// ϰ
//		   ڵ
//
HWND CImgvwIf::GetHwnd() const
{
	return m_hTrayWnd;
}