/* $Valkyrie: Valkyrie/Valkyrie/msgproc.cpp,v 1.6 2004/12/16 12:55:33 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// msgproc.cpp:   ޽ ڵ鷯
//

#include "stdafx.h"
#include "msgproc.h"
#include "util.h"
#include <xtrace.h>

#include "..\trayhk\trayhk.h"
#include "resource.h"

// Ű   ޽ ڵ鷯
// WM_CREATE, WM_DESTROY, WM_TRAYNOTIFY, WM_TRAYWHEEL, WM_COMMAND, WM_APPRELOADIMAGE ó
// WM_APPRELOADIMAGE - ̹   о̶ ޽
LRESULT CALLBACK ValkyrieMsgProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LRESULT	ret = 0;

	switch(uMsg)
	{
	case WM_CREATE:
		OnCreate(hwnd, wParam, lParam);
		break;

	case WM_DESTROY:
		OnDestroy(hwnd, wParam, lParam);
		break;

	case WM_TRAYNOTIFY:
		OnTrayNotify(hwnd, wParam, lParam);
		break;

	case WM_TRAYWHEEL:
		OnTrayWheel(hwnd, wParam, lParam);
		break;

	case WM_COMMAND:
		OnCommand(hwnd, wParam, lParam);
		break;

	case WM_APPRELOADIMAGE:
		{
			PVALKYRIEWNDDATA pvwd = (PVALKYRIEWNDDATA) GetProp(hwnd, VALKYRIE_WND_DATA);
			pvwd->filelist.LoadFromFile(pvwd->szImageDbPath);
		}
		break;

	default:
		ret = DefWindowProc(hwnd, uMsg, wParam, lParam);
	}

	return ret;
}

//
// WM_CREATE ޽ ڵ鷯
// 
//  õ VALKYRIEWNDDATA Ҵ 쿡 Ƽ 
// 콺  
// Ʈ  
//
void WINAPI OnCreate(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	NOTIFYICONDATA		nid;
	HICON				hIcon;
	PVALKYRIEWNDDATA	pvwd;

	pvwd = new VALKYRIEWNDDATA;
	InitializeCriticalSection(&pvwd->cs);
	pvwd->pImgvwIf = NULL;

	CheckAppDir("jnet", "valkyrie", pvwd->szAppDir);
	wsprintf(pvwd->szImageDbPath, "%s\\%s", pvwd->szAppDir, "images.txt");
	pvwd->filelist.LoadFromFile(pvwd->szImageDbPath);

	pvwd->TrayPos.Initialize();
	pvwd->TrayPos.SetNotifyIconInfo(hwnd, 1, WM_TRAYNOTIFY);

	SetProp(hwnd, VALKYRIE_WND_DATA, (HANDLE) pvwd);

	InstallHook(hwnd, WM_TRAYWHEEL);
	SetHookPause(TRUE);

	hIcon = (HICON) LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAIN), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

	ZeroMemory(&nid, sizeof nid);
	nid.cbSize = sizeof nid;
	nid.uFlags = NIF_ICON | NIF_MESSAGE;
	nid.uID = 1;
	nid.hWnd = hwnd;
	nid.uCallbackMessage = WM_TRAYNOTIFY;
	nid.hIcon = hIcon;
	
	Shell_NotifyIcon(NIM_ADD, &nid);
	DestroyIcon(hIcon);
}

//
// WM_DESTROY ޽ ڵ鷯
//
// Ʈ  
//  
// ü 
//
void WINAPI OnDestroy(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	NOTIFYICONDATA		nid;
	PVALKYRIEWNDDATA	pvwd;

	ZeroMemory(&nid, sizeof nid);
	nid.cbSize = sizeof nid;
	nid.uID = 1;
	nid.hWnd = hwnd;

	Shell_NotifyIcon(NIM_DELETE, &nid);

	RemoveHook();

	pvwd = (PVALKYRIEWNDDATA) GetProp(hwnd, VALKYRIE_WND_DATA);
	pvwd->filelist.SaveToFile(pvwd->szImageDbPath);

	EnterCriticalSection(&pvwd->cs);
	if(pvwd->pImgvwIf != NULL)
	{
		delete pvwd->pImgvwIf;
		pvwd->pImgvwIf = NULL;
	}
	LeaveCriticalSection(&pvwd->cs);

	DeleteCriticalSection(&pvwd->cs);
	delete pvwd;
	RemoveProp(hwnd, VALKYRIE_WND_DATA);

	PostQuitMessage(0);
}

// 
// WM_TRAYNOTIFY ޽ ڵ鷯
// Ʈ ޽ ڵ鷯 Լ
//
// WM_MOUSEHOVER ̹  DLL εؼ ȭ鿡 
// WM_MOUSELEAVE ̹  DLLνϽ 
//
void WINAPI OnTrayNotify(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	PVALKYRIEWNDDATA	pvwd;
	
	if(wParam == 1)
	{
		pvwd = (PVALKYRIEWNDDATA) GetProp(hwnd, VALKYRIE_WND_DATA);

		switch(lParam)
		{
		case WM_MOUSEMOVE:			
			pvwd->TrayPos.OnMouseMove();
			break;

		case WM_MOUSEHOVER:
			EnterCriticalSection(&pvwd->cs);
			if(pvwd->pImgvwIf == NULL && pvwd->filelist.Size() > 0)
			{
                SetHookPause(FALSE);

				RECT rcView;
				CalcViewRect(&rcView, 300, 200);
				pvwd->pImgvwIf = new CImgvwIf(NULL, rcView.left,rcView.top, 300, 200);
				pvwd->pImgvwIf->SetBitmap(pvwd->filelist.CurrentFileName());
				ShowWindow(pvwd->pImgvwIf->GetHwnd(), SW_SHOWNOACTIVATE);
			}
			LeaveCriticalSection(&pvwd->cs);
			break;

		case WM_MOUSELEAVE:
			EnterCriticalSection(&pvwd->cs);
			if(pvwd->pImgvwIf != NULL)
			{
				SetHookPause(TRUE);
				delete pvwd->pImgvwIf;
				pvwd->pImgvwIf = NULL;
			}
			LeaveCriticalSection(&pvwd->cs);
            NtSetProcessWorkingSetSize(GetCurrentProcess(), -1, -1);
			break;

		case WM_RBUTTONUP:
			{
				POINT	ptMouse;
				HMENU	hMenu = NULL;
				HMENU	hSubMenu = NULL;

				SetForegroundWindow(hwnd);

				GetCursorPos(&ptMouse);
				hMenu = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_TRAYMENU));

				if(hMenu != NULL)
				{
					hSubMenu = GetSubMenu(hMenu, 0);
					SetMenuDefaultItem(hSubMenu, ID_CONFIGIMGFILE, FALSE);
					if(hSubMenu != NULL)
						TrackPopupMenu(hSubMenu, TPM_LEFTALIGN | TPM_NONOTIFY | TPM_LEFTBUTTON, ptMouse.x, ptMouse.y, 0, hwnd, NULL);
                    DestroyMenu(hMenu);
				}

				
				PostMessage(hwnd, WM_NULL, 0, 0);
				NtSetProcessWorkingSetSize(GetCurrentProcess(), -1, -1);
			}
			break;

		case WM_MBUTTONUP:
			if(pvwd->filelist.Size() > 0)
				SetWallpaper(pvwd->filelist.CurrentFileName(), WPS_NONE);
			break;

		case WM_LBUTTONDBLCLK:
            PostMessage(hwnd, WM_COMMAND, MAKELONG(ID_CONFIGIMGFILE, 0), 0);
			break;
		}
	}
}

//
// WM_TRAYWHEEL ޽ ڵ鷯
// Ʈ̿   ߻ϴ ޽
// ŷ DLL  ۵Ǵ ޽
//
// Ķ
//		hwnd	[in]	 ڵ
//		wParam	[in]	 Ÿ 
//		lParma	[in]	 
//
void WINAPI OnTrayWheel(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	PVALKYRIEWNDDATA	pvwd;

	pvwd = (PVALKYRIEWNDDATA) GetProp(hwnd, VALKYRIE_WND_DATA);

	if((short)HIWORD(wParam) > 0)
	{
		pvwd->filelist.Next();
	}
	else
	{
		pvwd->filelist.Prev();
	}


	EnterCriticalSection(&pvwd->cs);
	if(pvwd->pImgvwIf != NULL)
		pvwd->pImgvwIf->SetBitmap(pvwd->filelist.CurrentFileName());
	LeaveCriticalSection(&pvwd->cs);
}

//
// WM_COMMAND ޽ ڵ鷯
//
// ID_EXIT - 
// ID_CONFIGIMGFILE - ٹ 
// ID_GOHOME - Ȩ ̵
// ID_SWNOCHANGE, ID_SWTILE, ID_SWSTRETCH, ID_SWCENTER - ȭ 
//
void WINAPI OnCommand(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	switch(LOWORD(wParam))
	{
	case ID_EXIT:
		DestroyWindow(hwnd);
		break;

	case ID_CONFIGIMGFILE:
		{
			HWND hImgCfgWnd = NULL;

			hImgCfgWnd = FindWindow("#32770", "Valkyrie ٹ ̹ ");

            if(hImgCfgWnd != NULL)
			{
				SetForegroundWindow(hImgCfgWnd);
			}

			else
			{
				typedef INT_PTR (WINAPI *FPopupImageListDlg)(HWND, LPCTSTR);
				HINSTANCE			hDll;
				FPopupImageListDlg	fnPopupImageListDlg;
				PVALKYRIEWNDDATA	pvwd;
				
				pvwd = (PVALKYRIEWNDDATA) GetProp(hwnd, VALKYRIE_WND_DATA);
				if(GetProcAddresses(&hDll, "imgcfg.dll", 1, &fnPopupImageListDlg, "PopupImageListDlg"))
				{
					pvwd->filelist.SaveToFile(pvwd->szImageDbPath);

					SetForegroundWindow(hwnd);
					if(fnPopupImageListDlg(hwnd, pvwd->szImageDbPath) == IDOK)
					{
						pvwd->filelist.LoadFromFile(pvwd->szImageDbPath);
					}
					FreeLibrary(hDll);

					SendMessage(hwnd, WM_APPRELOADIMAGE, 0, 0);

					NtSetProcessWorkingSetSize(GetCurrentProcess(), -1, -1);
				}
			}
		}
		break;

	case ID_GOHOME:
		ShellExecute(hwnd, "open", "http://valkyrie.kldp.net", NULL, NULL, SW_SHOW);
		break;

	case ID_SWNOCHANGE:
	case ID_SWSTRETCH:
	case ID_SWTILE:
	case ID_SWCENTER:
		{
			PVALKYRIEWNDDATA pvwd = (PVALKYRIEWNDDATA) GetProp(hwnd, VALKYRIE_WND_DATA);

			if(pvwd->filelist.Size() > 0)
				SetWallpaper(pvwd->filelist.CurrentFileName(), LOWORD(wParam)-ID_SWNOCHANGE-1);
		}
		break;
	}
}