/* $Valkyrie: Valkyrie/Valkyrie/msgproc.h,v 1.5 2004/12/16 12:55:33 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// msgproc.cpp:   ޽ ڵ鷯
//

#ifndef MSGPROC_H
#define MSGPROC_H

#include "traypos.h"
#include "imgvw_if.h"
#include "ImageFileList.h"

#define VALKYRIE_CLS_NAME	TEXT("ValkyrieHidden")
#define VALKYRIE_WND_DATA	TEXT("ValkyrieWndData")

#define WM_TRAYNOTIFY		(WM_USER+1394)
#define WM_TRAYWHEEL		(WM_USER+1395)
#define WM_APPRELOADIMAGE	(WM_APP+33)


typedef struct _VALKYRIEWNDDATA
{
    CMsgTrayPos			TrayPos;
	CImgvwIf			*pImgvwIf;

	CImageFileList		filelist;

	CRITICAL_SECTION	cs;

	TCHAR				szAppDir[MAX_PATH];
	TCHAR				szImageDbPath[MAX_PATH];
} VALKYRIEWNDDATA, *PVALKYRIEWNDDATA;

LRESULT CALLBACK ValkyrieMsgProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void WINAPI OnCreate(HWND hwnd, WPARAM wParam, LPARAM lParam);
void WINAPI OnDestroy(HWND hwnd, WPARAM wParam, LPARAM lParam);
void WINAPI OnTrayNotify(HWND hwnd, WPARAM wParam, LPARAM lParam);
void WINAPI OnTrayWheel(HWND hwnd, WPARAM wParam, LPARAM lParam);
void WINAPI OnCommand(HWND hwnd, WPARAM wParam, LPARAM lParam);

#endif