/* $Valkyrie: Valkyrie/Valkyrie/traypos.cpp,v 1.8 2004/12/16 12:55:33 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// traypos.cpp: Ʈ̿ 콺 Hover/Leave ޽ 
//

#include "stdafx.h"
#include <commctrl.h>
#include <process.h>
#include <xtrace.h>

#include "traypos.h"
#include "resource.h"

//
//   ̺Ʈ , ũƼ  ʱȭ,  ڵ鰪 ʱȭ
// ! ⼭ 带  Ƿ  Initialize ȣؾ 
//
CTrayPos::CTrayPos()
{
	m_bTrackMouse = FALSE;
	m_hExitEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	m_hThread = NULL;
	InitializeCriticalSection(&m_cs);
}

//
//  
// ̺Ʈ, ũƼ ,  ڵ 
//
CTrayPos::~CTrayPos()
{
	if(m_hThread != NULL)
	{
		SetEvent(m_hExitEvent);
		if(WaitForSingleObject(m_hThread, 5000) == WAIT_TIMEOUT)
		{
			TerminateThread(m_hThread, 0);
		}

		CloseHandle(m_hThread);
		m_hThread = NULL;
	}

	if(m_hExitEvent != NULL)
	{
		CloseHandle(m_hExitEvent);
		m_hExitEvent = NULL;
	}

	DeleteCriticalSection(&m_cs);
}

// 
//   Լ
// ι  ȣ ƹ ϵ  
//
// Ķ
//		
//
// ϰ
//		  1,   0 
//
BOOL CTrayPos::Initialize()
{
	UINT uThreadId;

	if(!m_hThread)
		m_hThread = (HANDLE) _beginthreadex(NULL, 0, CTrayPos::TrackMousePt, this, 0, &uThreadId);

	return (m_hThread != NULL);
}

// 
// 콺 ǥ ˻ؼ WM_MOUSELEAVE Ǵϴ  Լ
//
// Ķ
//		pvClass	[in]	CTrayPos 
//
// ϰ
//		׻ 0
//
UINT CALLBACK CTrayPos::TrackMousePt(PVOID pvClass)
{
	POINT		ptMouse;
	CTrayPos	*pTrayPos = (CTrayPos *) pvClass;

	while(WaitForSingleObject(pTrayPos->m_hExitEvent, 2000) == WAIT_TIMEOUT)
	{

		if(pTrayPos->m_bTrackMouse == TRUE)
		{
			GetCursorPos(&ptMouse);
			
			if(ptMouse.x != pTrayPos->m_ptMouse.x || ptMouse.y != pTrayPos->m_ptMouse.y)
			{
				pTrayPos->m_bTrackMouse = FALSE;
				pTrayPos->OnMouseLeave();
			}
		}
	}

	return 0;
}

//
// Ʈ̿ WM_MOUSEMOVE ޽ ߻  ȣؾ ϴ Լ
//  콺 ǥ 
// ó ߻  WM_MOUSEHOVER 
//
// Ķ, ϰ 
//
void CTrayPos::OnMouseMove()
{
	EnterCriticalSection(&m_cs);

	GetCursorPos(&m_ptMouse);
	if(m_bTrackMouse == FALSE)
	{
		OnMouseEnter();
		m_bTrackMouse = TRUE;
	}

	LeaveCriticalSection(&m_cs);
}

//
//  ° Hover Ǵ
//
BOOL CTrayPos::IsMouseOver() const
{
	return m_bTrackMouse;
}

//
// Ķ - SetNotifyIcon 
//
CMsgTrayPos::CMsgTrayPos(HWND hwnd, UINT uID, UINT uCallbackMsg)
	: CTrayPos()
{
	SetNotifyIconInfo(hwnd, uID, uCallbackMsg);
}

//
// Ҹ
//
CMsgTrayPos::~CMsgTrayPos()
{
}

//
// Ʈ ޽   
//
// Ķ
//		hwnd			[in]	޽   ڵ
//		uID				[in]	Ʈ  ̵	
//		uCallbackMsg	[in]	Ʈ ޽
//
// ϰ 
//
void CMsgTrayPos::SetNotifyIconInfo(HWND hwnd, UINT uID, UINT uCallbackMsg)
{
	m_hNotifyWnd = hwnd;
	m_uID = uID;
	m_uCallbackMsg = uCallbackMsg;
}

//
// WM_MOUSEHOVER ޽ ߻ Լ
//
void CMsgTrayPos::OnMouseEnter()
{
	if(m_hNotifyWnd != NULL && IsWindow(m_hNotifyWnd))
		PostMessage(m_hNotifyWnd, m_uCallbackMsg, m_uID, WM_MOUSEHOVER);
}

//
// WM_MOUSELEAVE ޽ ߻ Լ
//
void CMsgTrayPos::OnMouseLeave()
{
	if(m_hNotifyWnd != NULL && IsWindow(m_hNotifyWnd))
		PostMessage(m_hNotifyWnd, m_uCallbackMsg, m_uID, WM_MOUSELEAVE);
}