/* $Valkyrie: Valkyrie/Valkyrie/traypos.h,v 1.6 2004/12/16 12:55:33 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// traypos.h: Ʈ̿ 콺 Hover/Leave ޽ 
//

#ifndef TRAYPOS_H
#define TRAYPOS_H

// 콺 Hover/Leave ٽ   Ŭ
//   Ŭ ӹ޾ OnMouseEnter, OnMouseLeave  Ͽ ϸ .
class CTrayPos
{
private:
	POINT				m_ptMouse;			//  WM_MOUSEMOVE ߻, ص ǥ
	
	
	HANDLE				m_hThread;			//  ڵ
	HANDLE				m_hExitEvent;		//   ̺Ʈ
	
	BOOL				m_bTrackMouse;		//  콺 Hover  Ÿ ÷

	CRITICAL_SECTION	m_cs;				// WM_MOUSEMOVE ο Ǵ ũƼ 

	
public:
	CTrayPos();
	virtual ~CTrayPos();
	
	static UINT CALLBACK TrackMousePt(PVOID pvClass);
	BOOL Initialize();

	BOOL IsMouseOver() const;

	void OnMouseMove();
	virtual void OnMouseEnter() = 0;
	virtual void OnMouseLeave() = 0;
};

// 콺 Hover/Leaveÿ WM_MOUSEHOVER, WM_MOUSELEAVE ޽ ϴ Ŭ
class CMsgTrayPos : public CTrayPos
{
private:
	HWND	m_hNotifyWnd;		// ޽   ڵ
	UINT	m_uID;				// Ʈ  ̵
	UINT	m_uCallbackMsg;		// Ʈ ݹ ޽

public:
	CMsgTrayPos(HWND hwnd=NULL, UINT uID=0, UINT uCallbackMsg=0);
	~CMsgTrayPos();

	void SetNotifyIconInfo(HWND hwnd, UINT uID, UINT uCallbackMsg);
	void OnMouseEnter();
	void OnMouseLeave();
};

#endif