/* $Valkyrie: Valkyrie/Valkyrie/util.cpp,v 1.12 2004/12/16 15:50:57 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// util.cpp:  ƿƼ Լ
//

#include "stdafx.h"
#include "util.h"
#include <direct.h>
#include <wininet.h>
#include <shlobj.h>

#include <xtrace.h>

//
// DLL   Լ ѹ εϴ Լ
//
// Ķ
//		hLibrary	[out]	 DLL ڵ
//		lpszLibrary	[in]	DLL 
//		nCount		[in]	ε Լ 
//		...			[in]	Լ Լ. ) "FunctionName", &FunctionPointer
//
// ϰ
//		  1,   0 
//

BOOL GetProcAddresses( HINSTANCE *hLibrary, LPCSTR lpszLibrary, INT nCount, ... )
{
    BOOL bRet = TRUE;
    va_list va;
    va_start( va, nCount );
	
    if ( ( *hLibrary = LoadLibrary( lpszLibrary ) ) 
        != NULL )
    {
        FARPROC * lpfProcFunction = NULL;
        LPSTR lpszFuncName = NULL;
        INT nIdxCount = 0;
        while ( nIdxCount < nCount )
        {
            lpfProcFunction = va_arg( va, FARPROC* );
            lpszFuncName = va_arg( va, LPSTR );
            if ( ( *lpfProcFunction = 
                GetProcAddress( *hLibrary, 
				lpszFuncName ) ) == NULL )
            {
                lpfProcFunction = NULL;
                bRet = FALSE;
                break;
            }
            nIdxCount++;
        }
    }
    else
    {
		bRet = FALSE;
    }
    va_end( va );
	
	if(bRet == FALSE && *hLibrary != NULL)
		FreeLibrary(*hLibrary);
	
    return bRet;
}

//
// ŷ ϴ Լ
//
// Ķ
//		hProcess	[in]	μ ڵ
//		dwMin		[in]	ŷ ּ 
//		dwMax		[in]	ŷ ִ 
//
// ϰ
//		  1,   0 
//

BOOL WINAPI NtSetProcessWorkingSetSize(HANDLE hProcess, SIZE_T dwMin, SIZE_T dwMax)
{
	typedef BOOL (WINAPI *FSetProcessWorkingSetSize)(HANDLE, SIZE_T, SIZE_T);

	BOOL						bRet = FALSE;
	HINSTANCE					hInst;
	FSetProcessWorkingSetSize	fnSetProcessWorkingSetSize;

	hInst = GetModuleHandle("kernel32.dll");
	fnSetProcessWorkingSetSize = (FSetProcessWorkingSetSize) GetProcAddress(hInst, "SetProcessWorkingSetSize");
	if(fnSetProcessWorkingSetSize)
		bRet = fnSetProcessWorkingSetSize(hProcess, dwMin, dwMax);

	return bRet;
}

//
// ø̼  ˻ Լ
//
// Ķ
//		lpszCompany	[in]	ȸ
//		lpszProduct	[in]	ǰ
//		lpszPath	[out]	ø̼ 
//
// ϰ
//		
//
void CheckAppDir(LPCTSTR lpszCompany, LPCTSTR lpszProduct, LPTSTR lpszPath)
{
	TCHAR	szAppDataDir[MAX_PATH] = {0};
	TCHAR	szDestDir[MAX_PATH] = {0};

	SHGetSpecialFolderPath(NULL, szAppDataDir, CSIDL_APPDATA, FALSE);
	strcpy(szDestDir, szAppDataDir);

	strcat(szDestDir, "\\");
	strcat(szDestDir, lpszCompany);
	if(_chdir(szDestDir) != 0)
		_mkdir(szDestDir);

	strcat(szDestDir, "\\");
	strcat(szDestDir, lpszProduct);
	if(_chdir(szDestDir) != 0)
		_mkdir(szDestDir);

	strcpy(lpszPath, szDestDir);
}

//
// ȭ  Լ
//
// Ķ
//		lpszWallpaperFile	[in]	ȭ 
//		dwWallpaperStyle	[in]	ȭ Ÿ (, ٵǽ, ø,...)
//
// ϰ
//		  1,   0 
//
BOOL SetWallpaper(LPCTSTR lpszWallpaperFile, DWORD dwWallpaperStyle)
{
	HRESULT			hr;
	BOOL			bSetOldWay = FALSE;
	IActiveDesktop	*pIActiveDesktop;
	LPCTSTR			pszExt;
	BOOL			bRet = FALSE;
	
	CoInitialize(NULL);

	pIActiveDesktop = NULL;
	hr = CoCreateInstance(CLSID_ActiveDesktop, NULL, CLSCTX_INPROC_SERVER, IID_IActiveDesktop, (void**) &pIActiveDesktop);

	pszExt = strrchr(lpszWallpaperFile, '.');
	if(pszExt != NULL && pszExt+1 != NULL && stricmp(pszExt+1, "bmp") == 0)
		bSetOldWay = TRUE;

	if(SUCCEEDED(hr))
	{
		COMPONENTSOPT	compOptions;
		WALLPAPEROPT	wpOptions;
		wchar_t		wszWallpaperFile[MAX_PATH];

		compOptions.dwSize = sizeof compOptions;
		pIActiveDesktop->GetDesktopItemOptions(&compOptions, 0);

		if(compOptions.fActiveDesktop == TRUE || bSetOldWay == FALSE)
		{
			if(compOptions.fActiveDesktop == FALSE)
			{
				compOptions.dwSize = sizeof compOptions;
				compOptions.fActiveDesktop = TRUE;
				compOptions.fEnableComponents = FALSE;

				hr = pIActiveDesktop->SetDesktopItemOptions(&compOptions, 0);
			}

			if(dwWallpaperStyle != -1)
			{
				wpOptions.dwSize = sizeof wpOptions;
				wpOptions.dwStyle = dwWallpaperStyle;
				pIActiveDesktop->SetWallpaperOptions(&wpOptions, 0);
			}

			MultiByteToWideChar(CP_ACP, 0, lpszWallpaperFile, -1, wszWallpaperFile, sizeof wszWallpaperFile);
			hr = pIActiveDesktop->SetWallpaper(wszWallpaperFile, 0);
			hr = pIActiveDesktop->ApplyChanges(AD_APPLY_ALL);
			bRet = TRUE;
		}

		pIActiveDesktop->Release();
	}


	if(bSetOldWay == TRUE)
	{
		HKEY	hkey;

		if(dwWallpaperStyle != -1)
		{
			if(RegCreateKey(HKEY_CURRENT_USER, "Control Panel\\Desktop", &hkey) == ERROR_SUCCESS)
			{
				TCHAR	szTile[3] = "0";
				TCHAR	szWallpaperStyle[3] = "0";

				if(dwWallpaperStyle == WPSTYLE_TILE)
					strcpy(szTile, "1");

				wsprintf(szWallpaperStyle, "%s", dwWallpaperStyle);

				RegSetValueEx(hkey, "TileWallpaper", 0, REG_SZ, (LPCBYTE) szTile, (DWORD) strlen(szTile));
				RegSetValueEx(hkey, "TileWallpaper", 0, REG_SZ, (LPCBYTE) szWallpaperStyle, (DWORD) strlen(szWallpaperStyle));
				RegCloseKey(hkey);
			}
		}

		SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, (PVOID) lpszWallpaperFile, SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);	
		bRet = TRUE;
	}

	CoUninitialize();

 	return bRet;
}

//
//  ޴  Լ
// HKEY_CLASSES_ROOT\lpszExt\shell\lpszMenuName  lpszDispName 
// HKEY_CLASSES_ROOT\lpszExt\shell\lpszMenuName\command  lpszCommand 
//
// Ķ
//		lpszExt			[in]	Ȯ
//		lpszMenuName	[in]	޴ ̸
//		lpszDispName	[in]	µ ̸
//		lpszCommand		[in]	Ŀǵ
//
//	ϰ
//		  1,   0 
//
//

BOOL CreateShellMenu(LPCTSTR lpszExt, LPCTSTR lpszMenuName, LPCTSTR lpszDispName, LPCTSTR lpszCommand)
{
	HKEY	hkey;
	TCHAR	szExtClass[MAX_PATH];
	TCHAR	szSubKey[MAX_PATH];
	LONG	lSize = sizeof szExtClass;
	BOOL	bRet = FALSE;

	if(RegQueryValue(HKEY_CLASSES_ROOT, lpszExt, szExtClass, &lSize) == ERROR_SUCCESS)
	{
		if(RegCreateKey(HKEY_CLASSES_ROOT, szExtClass, &hkey) == ERROR_SUCCESS)
		{
			wsprintf(szSubKey, "shell\\%s", lpszMenuName);
			RegSetValue(hkey, szSubKey, REG_SZ, lpszDispName, DWORD(strlen(lpszDispName)));

			wsprintf(szSubKey, "shell\\%s\\command", lpszMenuName);
			RegSetValue(hkey, szSubKey, REG_SZ, lpszCommand, DWORD(strlen(lpszCommand)));

			RegCloseKey(hkey);

			bRet = TRUE;
		}
	}

	return bRet;
}

//
//  ޴  Լ
// HKEY_CLASSES_ROOT\lpszExt\shell\lpszMenuName 
// HKEY_CLASSES_ROOT\lpszExt\shell\lpszMenuName\command 
//
// Ķ
//		lpszExt			[in]	Ȯ
//		lpszMenuName	[in]	޴ ̸
//
// ϰ
//		  1,   0 
//

BOOL DeleteShellMenu(LPCTSTR lpszExt, LPCTSTR lpszMenuName)
{
	HKEY	hkey;
	TCHAR	szExtClass[MAX_PATH];
	TCHAR	szSubKey[MAX_PATH];
	LONG	lSize = sizeof szExtClass;
	BOOL	bRet = FALSE;

	if(RegQueryValue(HKEY_CLASSES_ROOT, lpszExt, szExtClass, &lSize) == ERROR_SUCCESS)
	{
		if(RegCreateKey(HKEY_CLASSES_ROOT, szExtClass, &hkey) == ERROR_SUCCESS)
		{
			wsprintf(szSubKey, "shell\\%s\\command", lpszMenuName);
			RegDeleteKey(hkey, szSubKey);

			wsprintf(szSubKey, "shell\\%s", lpszMenuName);
			RegDeleteKey(hkey, szSubKey);

			RegCloseKey(hkey);
			bRet = TRUE;
		}
	}

	return bRet;
}

//
// View  ġ ϴ Լ
// Valkyrie   View ġ ۾   ϴ Ǿ 
//
// Ķ
//		lprc	[out]	View  ġ Ÿ (ũ ǥ)
//		w		[in]	View   ũ
//		h		[in]	View   ũ
//
// ϰ
//		
//
void WINAPI CalcViewRect(LPRECT lprc, int w, int h)
{
	RECT rcWorkArea;

	SystemParametersInfo(SPI_GETWORKAREA, 0, &rcWorkArea, FALSE);

	lprc->left = rcWorkArea.right - w - 5;
	lprc->top = rcWorkArea.bottom - h - 5;
	lprc->right = lprc->left + w;
	lprc->bottom = lprc->top + h;
}
