/* $Valkyrie: Valkyrie/Valkyrie/valkyrie.cpp,v 1.26 2004/12/16 12:55:33 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// valkyrie.cpp: valkyrie  ν
//

#include "stdafx.h"

#include <shellapi.h>

#include "TrayPos.h"
#include "imgvw_if.h"
#include "singleinst.h"
#include "util.h"
#include "imagefilelist.h"
#include "msgproc.h"

//
// Valkyrie  ν
//
// Ŀǵ  ɼ
//		 - Ű ø
//		/a - Ű ٹ ̹ ߰
//		/reg - Ʈ Ű ޴ ߰
//		/unreg - Ʈ Ű ޴ 
//
int CALLBACK WinMain(HINSTANCE hInst, HINSTANCE, LPSTR lpszCmdLine, int)
{
	WNDCLASS				wc;
	MSG						msg;
	HWND					hwnd;
	char					*pszTok;
	CSingleInstance			inst("Valkyrie_Instance_Mutex");

	pszTok = strtok(lpszCmdLine, " ");
	if(pszTok == NULL)
	{
		if(inst.IsExist() == FALSE)
		{
			wc.cbClsExtra		= 0;
			wc.cbWndExtra		= 0;
			wc.hbrBackground	= NULL;
			wc.hCursor			= NULL;
			wc.hIcon			= NULL;
			wc.hInstance		= hInst;
			wc.lpfnWndProc		= ValkyrieMsgProc;
			wc.lpszClassName	= VALKYRIE_CLS_NAME;
			wc.lpszMenuName		= NULL;
			wc.style			= 0;

			RegisterClass(&wc);

			hwnd = CreateWindow(VALKYRIE_CLS_NAME, "", WS_POPUP | WS_CLIPSIBLINGS, 0, 0, 0, 0, NULL, NULL, hInst, NULL);
			ShowWindow(hwnd, SW_HIDE);

			while(GetMessage(&msg, NULL, 0, 0))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}

			UnregisterClass(VALKYRIE_CLS_NAME, hInst);
		}
	}
	else if(stricmp(pszTok, "/a") == 0)
	{
		TCHAR			szAppDir[MAX_PATH];
		TCHAR			szImageDbPath[MAX_PATH];
		CImageFileList	ifl;

		CheckAppDir("jnet", "valkyrie", szAppDir);
		wsprintf(szImageDbPath, "%s\\%s", szAppDir, "images.txt");
		
        ifl.LoadFromFile(szImageDbPath);

		if((pszTok=strtok(NULL, "")) != NULL)
			ifl.AddImage(pszTok);

		ifl.SaveToFile(szImageDbPath);

		if(inst.IsExist())
		{
			HWND hDest = FindWindow(VALKYRIE_CLS_NAME, NULL);

			if(hDest != NULL)
                SendMessage(hDest, WM_APPRELOADIMAGE, 0, 0);
		}
	}
	else if(stricmp(pszTok, "/reg") == 0)
	{
		HKEY	hkey;
		DWORD	dwType;
		DWORD	dwSize;
		TCHAR	szInstallDir[MAX_PATH] = {0};
		TCHAR	szCmdLine[MAX_PATH];

		if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\jnet\\valkyrie", 0, KEY_READ, &hkey) == ERROR_SUCCESS)
		{
			dwSize = sizeof szInstallDir;
			RegQueryValueEx(hkey, "InstallDir", NULL, &dwType, (LPBYTE) szInstallDir, &dwSize);
			RegCloseKey(hkey);
		}

		if(strcmp(szInstallDir, "") != 0)
		{
			wsprintf(szCmdLine, "\"%s\\valkyrie.exe\" /a %%1", szInstallDir);

			CreateShellMenu(".bmp", "AddValkyrie", "Ű ٹ ߰", szCmdLine);
			CreateShellMenu(".gif", "AddValkyrie", "Ű ٹ ߰", szCmdLine);
			CreateShellMenu(".jpg", "AddValkyrie", "Ű ٹ ߰", szCmdLine);
			CreateShellMenu(".png", "AddValkyrie", "Ű ٹ ߰", szCmdLine);
		}
	}
	else if(stricmp(pszTok, "/unreg") == 0)
	{
		DeleteShellMenu(".bmp", "AddValkyrie");
		DeleteShellMenu(".gif", "AddValkyrie");
		DeleteShellMenu(".jpg", "AddValkyrie");
		DeleteShellMenu(".png", "AddValkyrie");
	}
	else if(stricmp(pszTok, "/quit") == 0)
	{
		if(inst.IsExist())
		{
			HWND hDest = FindWindow(VALKYRIE_CLS_NAME, NULL);

			if(hDest != NULL)
                SendMessage(hDest, WM_CLOSE, 0, 0);

			Sleep(1000);
		}
	}


	return 0;
}