/* $Valkyrie: Valkyrie/imgcfg/ImgListDlg.cpp,v 1.9 2004/12/16 15:50:57 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// ImgListDlg.cpp: ٹ  ̾˷α
//

#include "stdafx.h"
#include "imgcfg.h"
#include "ImgListDlg.h"
#include ".\imglistdlg.h"

// CImgListDlg ȭ Դϴ.

IMPLEMENT_DYNAMIC(CImgListDlg, CDialog)
CImgListDlg::CImgListDlg(LPCTSTR filename, CWnd* pParent /*=NULL*/)
	: CDialog(CImgListDlg::IDD, pParent)
{
	m_filename = filename;
}

CImgListDlg::~CImgListDlg()
{
}

void CImgListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_IMGLIST, m_clistImage);
	DDX_Control(pDX, IDC_PREVIEW, m_PreviewStatic);
	DDX_Control(pDX, IDC_FILEPATH, m_ceditFilePath);
}


BEGIN_MESSAGE_MAP(CImgListDlg, CDialog)
	ON_WM_DROPFILES()
//	ON_NOTIFY(LVN_ODSTATECHANGED, IDC_IMGLIST, OnLvnOdstatechangedImglist)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_IMGLIST, OnLvnItemchangedImglist)
	ON_BN_CLICKED(IDC_ADD, OnBnClickedAdd)
	ON_BN_CLICKED(IDC_DEL, OnBnClickedDel)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()


// CImgListDlg ޽ óԴϴ.

BOOL CImgListDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ⿡ ߰ ʱȭ ۾ ߰մϴ.
	CHeaderCtrl	hctrl;

	hctrl.Attach(m_clistImage.GetDlgItem(0)->m_hWnd);
	hctrl.ModifyStyle(HDS_BUTTONS, 0);
	hctrl.Detach();

	m_clistImage.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_FLATSB);

	ModifyStyleEx(0, WS_EX_ACCEPTFILES);

	m_clistImage.InsertColumn(0, "ϸ", LVCFMT_LEFT, 350, 0);

	InitList();

	CRect rcPreview;
	m_PreviewStatic.GetWindowRect(&rcPreview);
	ScreenToClient(&rcPreview);
	m_PreviewWnd.CreateEx(WS_EX_CLIENTEDGE, PREVIEW_CLSNAME, "", WS_CHILD | WS_VISIBLE, rcPreview, this, 1);

	GetWindowRect(m_MinRect);

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CImgListDlg::InitList()
{
	FILE	*fp = NULL;
	TCHAR	buffer[MAX_PATH];

	fp = fopen(m_filename, "rt");
	if(fp)
	{
		while(fgets(buffer, sizeof(buffer)-1, fp) != NULL)
		{
			REMOVE_CRLF(buffer);
			AddImage(buffer);
		}

		fclose(fp);
	}
}

void CImgListDlg::OnDropFiles(HDROP hDropInfo)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	TCHAR	szFilePath[MAX_PATH] = {0};
	UINT	uSize;
	UINT	i;

	uSize = DragQueryFile(hDropInfo, -1, NULL, 0);

	for(i=0; i<uSize; ++i)
	{
		DragQueryFile(hDropInfo, i, szFilePath, sizeof szFilePath);
		AddImage(szFilePath);
	}

	CDialog::OnDropFiles(hDropInfo);
}

//void CImgListDlg::OnLvnOdstatechangedImglist(NMHDR *pNMHDR, LRESULT *pResult)
//{
//	LPNMLVODSTATECHANGE pStateChanged = reinterpret_cast<LPNMLVODSTATECHANGE>(pNMHDR);
//	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
//
//	if(pStateChanged->uNewState & LVIS_SELECTED)
//	{
//		TCHAR szFileName[MAX_PATH];
//		m_clistImage.GetItemText(pStateChanged->iFrom, 0, szFileName, sizeof szFileName);
//		m_PreviewWnd.SetBitmapFile(szFileName);
//	}
//
//	*pResult = 0;
//}

void CImgListDlg::OnLvnItemchangedImglist(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if(pNMLV->uNewState & LVIS_SELECTED)
	{
		m_PreviewWnd.SetBitmapFile(m_clistImage.GetItemText(pNMLV->iItem, 0));
		m_ceditFilePath.SetWindowText(m_clistImage.GetItemText(pNMLV->iItem, 0));
	}

	*pResult = 0;
}

void CImgListDlg::AddImage(LPCTSTR lpszFileName)
{
	/*
	LPCTSTR pszFileName;

	pszFileName = strrchr(lpszFileName, '\\');
	if(pszFileName == NULL)
		pszFileName = lpszFileName;
	else
		++pszFileName;
	*/

	//m_clistImage.InsertItem(m_clistImage.GetItemCount(), pszFileName);
	m_clistImage.InsertItem(m_clistImage.GetItemCount(), lpszFileName);
}

void CImgListDlg::OnBnClickedAdd()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	OPENFILENAME ofn;
	char szFile[4096];

	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = m_hWnd;
	ofn.lpstrFile = szFile;

	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "̹ \0*.jpg;*.bmp;*.gif;*.png\0 \0*.*\0";
	ofn.nFilterIndex = 0;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_ALLOWMULTISELECT | OFN_EXPLORER;

	if (GetOpenFileName(&ofn)==TRUE) 
	{
		size_t	nIdx = 0;
		TCHAR	szDir[MAX_PATH];
		TCHAR	szBuffer[MAX_PATH];

        strcpy(szDir, szFile);
		nIdx = ofn.nFileOffset;
        
		if(strlen(szDir) < nIdx)
		{
			while(szFile[nIdx] != '\0')
			{
				wsprintf(szBuffer, "%s\\%s", szDir, szFile+nIdx);
				nIdx += strlen(szFile+nIdx)+1;

				AddImage(szBuffer);
			}
		}
		else
		{
			AddImage(szDir);
		}
	}
}

void CImgListDlg::OnBnClickedDel()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	POSITION	pd;
	int			nSel;

	pd = m_clistImage.GetFirstSelectedItemPosition();

	while(pd)
	{
		nSel = m_clistImage.GetNextSelectedItem(pd);

		if(nSel != -1)
		{
			m_clistImage.DeleteItem(nSel);
			pd = m_clistImage.GetFirstSelectedItemPosition();
		}
	}
}

void CImgListDlg::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    FILE *fp;

	fp = fopen(m_filename, "wt");
    if(fp)
	{
		for(int i=0; i<m_clistImage.GetItemCount(); ++i)
		{
			fprintf(fp, "%s\n", m_clistImage.GetItemText(i, 0));
		}

		fclose(fp);
	}

	OnOK();
}

void CImgListDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	CDialog::OnGetMinMaxInfo(lpMMI);

	lpMMI->ptMinTrackSize.x = m_MinRect.Width();
	lpMMI->ptMinTrackSize.y = m_MinRect.Height();
}
