/* $Valkyrie: Valkyrie/imgcfg/PreviewWnd.cpp,v 1.9 2004/12/16 12:55:33 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// PreviewWnd.cpp: ̸ 
//

#include "stdafx.h"
#include "imgcfg.h"
#include "PreviewWnd.h"

#include ".\previewwnd.h"
#include <xtrace.h>

// CPreviewWnd

IMPLEMENT_DYNAMIC(CPreviewWnd, CWnd)
CPreviewWnd::CPreviewWnd()
{
	m_bCapture = FALSE;
	m_bUpdateScroll = TRUE;

	m_pimgOrigin = NULL;
	m_nScale = 0;
}

CPreviewWnd::~CPreviewWnd()
{
}


BEGIN_MESSAGE_MAP(CPreviewWnd, CWnd)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_VSCROLL()
	ON_WM_CREATE()
	ON_WM_HSCROLL()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_ERASEBKGND()
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()



// CPreviewWnd ޽ óԴϴ.

BOOL CPreviewWnd::LoadImage()
{
	BOOL	bRet = FALSE;
	Image	*pImg;
	
	pImg = new Image(m_wszBitmapFileName);
	if(pImg->GetLastStatus() == Ok)
	{
		m_pimgOrigin = pImg;
		m_nScale = GetFitOnWindowScale();
		RescaleImage(m_nScale);
		bRet = TRUE;
	}

	return bRet;
}

BOOL CPreviewWnd::RotateImage()
{
	BOOL	bRet = FALSE;

	if(m_pimgOrigin)
	{
		if(m_pimgOrigin->RotateFlip(Rotate90FlipX) == Ok && RescaleImage(m_nScale))
			bRet = TRUE;
	}

	return bRet;
}

float CPreviewWnd::GetFitOnWindowScale()
{
	float	fRatio;

    if(m_pimgOrigin != NULL)
	{
		SIZE	szImage;
		SIZE	szDestImage;

		CRect	rcClient;		
		float	fRatioX;
		float	fRatioY;

		szImage.cx = m_pimgOrigin->GetWidth();
		szImage.cy = m_pimgOrigin->GetHeight();

		GetClientRect(&rcClient);

		fRatioX = rcClient.Width() / (float) szImage.cx;
		fRatioY = rcClient.Height() / (float) szImage.cy;

		if(fRatioX > 1 && fRatioY > 1)
			fRatio = 1;
		else
			fRatio = (fRatioX < fRatioY) ? fRatioX : fRatioY;

		szDestImage.cx = (int)(fRatio * szImage.cx);
		szDestImage.cy = (int)(fRatio * szImage.cy);
	}

	return fRatio;
}

BOOL CPreviewWnd::RescaleImage()
{
	BOOL	bRet = FALSE;

#if 0
	if(m_pimgOrigin != NULL)
	{
		CRect	rcClient;
		POINT	ptDraw;
		SIZE	szImage;
		SIZE	szDest;
		Bitmap		*pBmpNew = NULL;

		GetClientRect(&rcClient);

		szImage.cx = m_pimgOrigin->GetWidth() * m_nScale;
		szImage.cy = m_pimgOrigin->GetHeight() * m_nScale;

		if(szImage.cx < rcClient.Width() && szImage.cy < rcClient.Height())
		{
			pBmpNew = new Bitmap(szImage.cx, szImage.cy);
			Graphics	grp(pBmpNew);

			grp.DrawImage(m_pimgOrigin, 0, 0, szImage.cx, szImage.cy);
		}
		else
		{
			int	vx, vy, vw, vh;
			int ox, oy, ow, oh;

			SCROLLINFO	siVert = {sizeof siVert, SIF_POS, };
			SCROLLINFO	siHorz = {sizeof siHorz, SIF_POS, };
			GetScrollInfo(SB_VERT, &siVert);
			GetScrollInfo(SB_HORZ, &siHorz);

			for(vx=siHorz.nPos-siHorz.nPage; vx<0; vx+=siHorz.nPage)
				;
			for(vw=siHorz.nPage+vx; vw+vx<=szImage.cx && vw<=siHorz.nPage*3; vw+=siHorz.nPage)
				;

			for(vy=siHorz.nPos-siHorz.nPage; vy<0; vy+=siHorz.nPage)
				;
			for(vh=siHorz.nPage+vy; vh+vy<=szImage.cy && vw<=siVert.nPage*3; vh+=siHorz.nPage)
				;

			ox = vx/m_nScale;
			oy = vy/m_nScale;
			ow = vw/m_nScale;
			oh = vh/m_nScale;

			m_ptImgScrollPos.x = vx;
			m_ptImgScrollPos.y = vy;

			pBmpNew = new Bitmap(szImage.cx, szImage.cy);
			Graphics grp(pBmpNew);

			grp.DrawImage(m_pimgOrigin, Rect(vx, vy, vw, vh), ox, oy, ow, oh, UnitPixel);
		}

		if(pBmpNew)
		{
			if(m_pimgDisplay != NULL)
				delete m_pimgDisplay;

			m_pimgDisplay = pBmpNew;
			bRet = TRUE;
		}
	}
#endif

	return bRet;
}

BOOL CPreviewWnd::RescaleImage(float nScale)
{
	BOOL	bRet = FALSE;

	/*
	int		ox, oy, ow, oh;

	ox = x/m_nScale+0.5;
	oy = y/m_nScale+0.5;
	ow = w/m_nScale+0.5;
	oh = h/m_nScale+0.5;

	Bitmap	bmpOrig(ow, oh);
	Bitmap	*pBmpNew = new Bitmap(w, h);

	Graphics	grpOrig(&bmpOrig);
	Graphics	grpNew(pBmpNew);

	grpOrig.DrawImage(m_pimgOrigin, 0, 0, ox, oy, ow, oh, UnitPixel);
	grpNew.DrawImage(&bmpOrig, 0, 0, w, h);

	return pBmpNew;
	*/

#if 0
    if(m_pimgOrigin != NULL)
	{
		SIZE	szImage;
		SIZE	szDestImage;
		Bitmap	*pBmpNew;

		szImage.cx = m_pimgOrigin->GetWidth();
		szImage.cy = m_pimgOrigin->GetHeight();
		
		szDestImage.cx = nScale * szImage.cx;
		szDestImage.cy = nScale * szImage.cy;

		//pImgNew = m_pimgOrigin->GetThumbnailImage(szDestImage.cx, szDestImage.cy);
		pBmpNew = new Bitmap(szDestImage.cx, szDestImage.cy);
		if(pBmpNew)
		{
			if(m_pimgDisplay)
				delete m_pimgDisplay;

			Graphics grp(pBmpNew);
			grp.DrawImage(m_pimgOrigin, 0, 0, szDestImage.cx, szDestImage.cy);

			m_pimgDisplay = pBmpNew;
			bRet = TRUE;
		}
	}
#endif

	return bRet;
}

Image *CPreviewWnd::GetResizedImage(int x, int y, int w, int h)
{
	return NULL;
}

BOOL CPreviewWnd::SetScroll(BOOL bRemove)
{
	SCROLLINFO	si;
	BOOL		bUpdate = FALSE;

	XTRACE("??????? SetScroll %d", bRemove);

	if(bRemove)
	{
		si.cbSize = sizeof si;
		si.fMask = SIF_ALL;
		si.nMin = 0;
		si.nMax = 0;
		si.nPage = 1;
		si.nPos = 0;
		SetScrollInfo(SB_HORZ, &si, TRUE);

		si.nMax = 0;
		si.nPage = 1;
		SetScrollInfo(SB_VERT, &si, TRUE);
		bUpdate = TRUE;
	}
	else if(m_bUpdateScroll && m_pimgOrigin)
	{
		CRect rcClient;
		GetClientRect(&rcClient);

		si.cbSize = sizeof si;
		si.fMask = SIF_ALL;
        GetScrollInfo(SB_HORZ, &si);

		si.nPos = (int)(m_pimgOrigin->GetWidth() * m_nScale * si.nPos / si.nMax);
		si.nMin = 0;
		si.nMax = (int)(m_pimgOrigin->GetWidth() * m_nScale);
		si.nPage = rcClient.Width();		
		SetScrollInfo(SB_HORZ, &si, TRUE);

		si.cbSize = sizeof si;
		si.fMask = SIF_ALL;
        GetScrollInfo(SB_VERT, &si);

		si.nPos = (int)(m_pimgOrigin->GetHeight() * m_nScale * si.nPos / si.nMax);
		si.nMax = (int)(m_pimgOrigin->GetHeight() * m_nScale);
		si.nPage = rcClient.Height();
		XTRACE("SI : %d, %d", si.nPos, si.nMax);
		SetScrollInfo(SB_VERT, &si, TRUE);
		bUpdate = TRUE;
	}

	return bUpdate;
}

void CPreviewWnd::BlitPage(Graphics &vs, int x, int y)
{
	/*
	CRect	rcOrigin;
	Rect	rcDest(x*PCS, y*PCS, PCS, PCS);
	float	fScale;

	fScale = PCS/m_nScale;

	rcOrigin.SetRect(x*fScale, y*fScale, x*fScale+fScale, y*fScale+fScale);

	vs.DrawImage(m_pimgOrigin, rcDest, rcOrigin.left, rcOrigin.top, rcOrigin.Width(), rcOrigin.Height(), UnitPixel);
	*/
}


void CPreviewWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	// ׸ ޽ ؼ CWnd::OnPaint()() ȣ ʽÿ.

    if(m_pimgOrigin)
	{
		CRect	rcClient;
		POINT	ptDraw;
		SIZE	szImage;

		GetClientRect(&rcClient);

		szImage.cx = (int)(m_pimgOrigin->GetWidth() * m_nScale);
		szImage.cy = (int)(m_pimgOrigin->GetHeight() * m_nScale);

		Bitmap bmpBuffer(rcClient.Width(), rcClient.Height());
		Graphics grpBuffer(&bmpBuffer);

		Pen	pen(Color(0,0,0), 5.0f);
		SolidBrush brs(Color(255,255,255));

		grpBuffer.FillRectangle(&brs, 0, 0, rcClient.Width(), rcClient.Height());

		XTRACE("SCALE.......... %f %d, %d, %d, %d", m_nScale, szImage.cx, szImage.cy, rcClient.Width(), rcClient.Height());


		if(szImage.cx < rcClient.Width() && szImage.cy < rcClient.Height())
		{
			ptDraw.x = (rcClient.Width() - szImage.cx) / 2;
			ptDraw.y = (rcClient.Height() - szImage.cy) / 2;

			grpBuffer.DrawImage(m_pimgOrigin, ptDraw.x, ptDraw.y, szImage.cx, szImage.cy);
		}
		else
		{
			ptDraw.x = 0;
			ptDraw.y = 0;
            
			CRect rcSrc;
			SCROLLINFO	siVert = {sizeof siVert, SIF_POS, };
			SCROLLINFO	siHorz = {sizeof siHorz, SIF_POS, };
			GetScrollInfo(SB_VERT, &siVert);
			GetScrollInfo(SB_HORZ, &siHorz);

			if(szImage.cx < rcClient.Width())
				ptDraw.x = (rcClient.Width() - szImage.cx) / 2;

			if(szImage.cy < rcClient.Height())
				ptDraw.y = (rcClient.Height() - szImage.cy) / 2;

			XTRACE("?????????? Draw %d, %d", szImage.cx, szImage.cy);
			//grpBuffer.DrawImage(m_pimgDisplay, ptDraw.x, ptDraw.y, szImage.cx, szImage.cy);
			//grpBuffer.DrawImage(m_pimgDisplay, 0, 0, ptDraw.x, ptDraw.y, rcClient.Width(), rcClient.Height(), UnitPixel);

			rcSrc.left = (int)(siHorz.nPos/m_nScale);
			rcSrc.top = (int)(siVert.nPos/m_nScale);
			rcSrc.right = (int)(rcSrc.left + rcClient.Width()/m_nScale);
			rcSrc.bottom = (int)(rcSrc.top + rcClient.Height()/m_nScale);
			grpBuffer.DrawImage(m_pimgOrigin, 
								Rect(ptDraw.x, ptDraw.y, rcClient.Width(), rcClient.Height()), 
								rcSrc.left, rcSrc.top, rcSrc.Width(), rcSrc.Height(), UnitPixel);
		}

		XTRACE("PPPPPPPPPPPPPPPPPPPPPPP");
		Graphics(dc.m_hDC).DrawImage(&bmpBuffer, 0, 0, rcClient.Width(), rcClient.Height());
			XTRACE("PPPPPPPPPPPPPPPPPPPPPPP2");
        
	}
	else
	{
		RECT	rcClient;
		HBRUSH	hbr;


		XTRACE("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");

		GetClientRect(&rcClient);
		hbr = (HBRUSH) GetStockObject(BLACK_BRUSH);
		FillRect(dc.GetSafeHdc(), &rcClient, hbr);
	}
}

void CPreviewWnd::SetBitmapFile(LPCTSTR lpszFileName)
{
	MultiByteToWideChar(CP_ACP, 0, lpszFileName, -1, m_wszBitmapFileName, sizeof m_wszBitmapFileName);
	SetScroll(TRUE);
    LoadImage();	
	InvalidateRect(NULL, FALSE);
}

void CPreviewWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	XTRACE("????????????On SIZE");
	if(SetScroll())
	{
		Invalidate(FALSE);
	}
}

void CPreviewWnd::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	int yInc = 0;
	SCROLLINFO	si = {sizeof si, SIF_ALL, };

	GetScrollInfo(SB_VERT, &si);
	switch(nSBCode)
	{
	case SB_LINEUP:
		--yInc;
		break;

	case SB_LINEDOWN:
		++yInc;
		break;

	case SB_PAGEUP:
		yInc -= si.nPage;
		break;

	case SB_PAGEDOWN:
		yInc += si.nPage;
		break;

	case SB_THUMBTRACK:
		yInc = nPos-si.nPos;
		break;
	}

	XTRACE("%d, %d, %d", si.nPos, si.nMax, yInc);

	if(si.nPos + yInc < 0)
		yInc=-si.nPos;

	if(si.nPos + yInc > si.nMax-(int)si.nPage)
	{		
		yInc = si.nMax-si.nPage-si.nPos;
	}

	si.nPos += yInc;

	SetScrollInfo(SB_VERT, &si);
	RescaleImage();
	ScrollWindow(0, -yInc, NULL, NULL);

	CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

int CPreviewWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  ⿡ Ưȭ ۼ ڵ带 ߰մϴ.
	SetScroll(TRUE);

	return 0;
}

void CPreviewWnd::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	int xInc = 0;
	SCROLLINFO	si = {sizeof si, SIF_ALL, };

	GetScrollInfo(SB_HORZ, &si);
	switch(nSBCode)
	{
	case SB_LINEUP:
		--xInc;
		break;

	case SB_LINEDOWN:
		++xInc;
		break;

	case SB_PAGEUP:
		xInc -= si.nPage;
		break;

	case SB_PAGEDOWN:
		xInc += si.nPage;
		break;

	case SB_THUMBTRACK:
		xInc = nPos-si.nPos;
		break;
	}

	XTRACE("%d, %d, %d", si.nPos, si.nMax, xInc);

	if(si.nPos + xInc < 0)
		xInc=-si.nPos;

	if(si.nPos + xInc > si.nMax-(int)si.nPage)
	{		
		xInc = si.nMax-si.nPage-si.nPos;
	}

	si.nPos += xInc;

	SetScrollInfo(SB_HORZ, &si);
	RescaleImage();
	ScrollWindow(-xInc, 0, NULL, NULL);

	CWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CPreviewWnd::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	m_bCapture = TRUE;
	SetCapture();

	m_ptStart.x = point.x;
	m_ptStart.y = point.y;

	CWnd::OnLButtonDown(nFlags, point);
}

void CPreviewWnd::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	m_bCapture = FALSE;
	ReleaseCapture();
	Invalidate(FALSE);

	CWnd::OnLButtonUp(nFlags, point);
}

void CPreviewWnd::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

    if(m_bCapture)
	{
        int xInc, yInc;
		SCROLLINFO	siHorz = {sizeof siHorz, SIF_ALL,};
		SCROLLINFO	siVert = {sizeof siVert, SIF_ALL,};

		GetScrollInfo(SB_HORZ, &siHorz);
		GetScrollInfo(SB_VERT, &siVert);		

		xInc = m_ptStart.x - point.x;
		yInc = m_ptStart.y - point.y;

		if(siHorz.nMax - siHorz.nMin <= 0 || (int)siHorz.nPage >= (siHorz.nMax - siHorz.nMin))
			xInc = 0;
		else
		{
			if(siHorz.nPos + xInc < 0)
				xInc = -siHorz.nPos;
			if(siHorz.nPos + xInc > siHorz.nMax - (int)siHorz.nPage)
				xInc = siHorz.nMax - siHorz.nPage - siHorz.nPos;
		}

		if(siVert.nMax - siVert.nMin <= 0 || (int)siVert.nPage >= (siVert.nMax - siVert.nMin))
			yInc = 0;
		else
		{
			if(siVert.nPos + yInc < 0)
				yInc = -siVert.nPos;
			if(siVert.nPos + yInc > siVert.nMax - (int)siVert.nPage)
				yInc = siVert.nMax - siVert.nPage - siVert.nPos;
		}

		siHorz.nPos += xInc;
		siVert.nPos += yInc;

		
		ScrollWindow(-xInc, -yInc, NULL, NULL);
		SetScrollInfo(SB_HORZ, &siHorz);
		SetScrollInfo(SB_VERT, &siVert);

		//RescaleImage();
		//Invalidate(FALSE);

		m_ptStart.x = point.x;
		m_ptStart.y = point.y;
		
		//Invalidate(FALSE);
			
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CPreviewWnd::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	/*
	SCROLLINFO siHorz = {sizeof siHorz, SIF_ALL, };
	SCROLLINFO siVert = {sizeof siVert, SIF_ALL, };

	GetScrollInfo(SB_HORZ, &siHorz);
	GetScrollInfo(SB_VERT, &siVert);

	ScrollWindow(-siHorz.nPos, -siVert.nPos);
	*/
	

	//SetScroll(TRUE);
	m_bUpdateScroll = FALSE;
	SetScroll(TRUE);
	m_nScale = GetFitOnWindowScale();
	RescaleImage(m_nScale);
	Invalidate(FALSE);
	//SetScroll(TRUE);
	m_bUpdateScroll = TRUE;
	
	CWnd::OnLButtonDblClk(nFlags, point);
}

BOOL CPreviewWnd::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
	cs.lpszClass = AfxRegisterWndClass(CS_DBLCLKS, LoadCursor(NULL, IDC_ARROW), NULL, NULL);

	return CWnd::PreCreateWindow(cs);
}

BOOL CPreviewWnd::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	return TRUE;
	//return CWnd::OnEraseBkgnd(pDC);
}

BOOL CPreviewWnd::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	static int idx = 7;
	const float scale[17] = {0.07f, 0.1f, 0.15f, 0.2f, 0.3f, 0.5f, 0.7f, 1.f, 1.5f, 2.f, 3.f, 5.f, 7.f, 10.f, 20.f, 30.f, 50.f};

	if(zDelta > 0)
	{
		++idx;
		if(idx >= 16)
			idx = 16;
		m_nScale = scale[idx];
		

	}
	else
	{
		--idx;
		if(idx < 0)
			idx = 0;
		m_nScale = scale[idx];
		

	}

	XTRACE("............ SCALE %f", m_nScale);
	//RescaleImage();

	SetScroll();
	Invalidate(FALSE);

	return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}
