/* $Valkyrie: Valkyrie/imgcfg/imgcfg_if.cpp,v 1.7 2004/12/16 12:55:33 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// imgcfg_if.cpp: ܺ ͽƮ Լ
//

#include "stdafx.h"
#include "imgcfg_if.h"

#include "resource.h"
#include "ImgListDlg.h"

#include <gdiplus.h>
using namespace Gdiplus;

//
// Ӽ  Ŭ  Լ
//
// Ķ
//		hInst		[in]	α׷ νϽ ڵ
//		szClassName	[in]	Ŭ
//		wProc		[in]	 ν
//
// ϰ 
//
static
VOID _RegisterBaseWndClass(HINSTANCE hInst, PSTR szClassName, WNDPROC wProc)
{
	WNDCLASS	wcs;
	
	if(GetClassInfo(hInst, szClassName, &wcs) == 0)
	{
		wcs.cbClsExtra		= 0;
		wcs.cbWndExtra		= 0;
		wcs.hbrBackground	= NULL;
		wcs.hCursor			= LoadCursor(NULL, IDC_ARROW);
		wcs.hIcon			= NULL;
		wcs.hInstance		= hInst;
		wcs.lpfnWndProc		= wProc;
		wcs.lpszClassName	= szClassName;
		wcs.lpszMenuName	= NULL;
		wcs.style			= 0;
		
		RegisterClass(&wcs);
	}
}

//
// ʱȭ Լ (Preview Ŭ , GDI+ ʱȭ)
//
// Ķ
//		ppGdiPlusToken	[out]	GDI+ ū
//
// ϰ
//		ϸ 1, ϸ 0 
//
static
BOOL WINAPI _Initialize(ULONG_PTR *ppGdiPlusToken)
{
	BOOL bRet = FALSE;

	_RegisterBaseWndClass(AfxGetApp()->m_hInstance, PREVIEW_CLSNAME, ::DefWindowProc);
	GdiplusStartupInput gdiplusStartupInput;
	if(GdiplusStartup(ppGdiPlusToken, &gdiplusStartupInput, NULL) == Ok)
		bRet = TRUE;

	return bRet;
}

//
//  Լ (Preview Ŭ , GDI+ )
//
// Ķ
//		pGdiplusToken	[in]	GDI+ ū
//
// ϰ 
//
static
VOID WINAPI _Cleanup(ULONG_PTR pGdiPlusToken)
{
	UnregisterClass(PREVIEW_CLSNAME, AfxGetApp()->m_hInstance);
	GdiplusShutdown(pGdiPlusToken);
}

//
// ٹ  ̾˷α  Լ
//
// Ķ
//		hParent		[in]	θ  ڵ
//		filename	[in]	ٹ  
//
// ϰ
//		DoModal 
//		ڰ Ȯ   IDOK,   IDCANCEL ϵ
//
IMGCFG_API
INT_PTR WINAPI PopupImageListDlg(HWND hParent, LPCTSTR filename)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	INT_PTR		ret = 0;
	ULONG_PTR	GdiPlusToken;

	if(_Initialize(&GdiPlusToken))
	{
		CImgListDlg	dlg(filename, CWnd::GetDesktopWindow());
		ret = dlg.DoModal();
		_Cleanup(GdiPlusToken);
	}

	return ret;
}