/* $Valkyrie: Valkyrie/trayhk/trayhk.cpp,v 1.7 2004/12/16 12:55:33 genie0610 Exp $ */

/* 
 * Copyright (c) 2004, YoungJin Shin <pop@jiniya.net>.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the 
 *    distribution. 
 * 3. Original authors' names are not deleted. 
 * 4. The authors' names are not used to endorse or promote products 
 *    derived from this software without specific prior written 
 *    permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 * 
 */ 

//
// trayhk.cpp: 콺 
//

#include "stdafx.h"
#include "trayhk.h"

typedef struct _SHRDATA
{
    HHOOK	hHook;			//  ڵ
	HWND	hNotifyWnd;		//   ڵ
	UINT	uCallbackMsg;	// ݹ ޽ ID
	BOOL	bHookPause;		//    (TRUE: , FALSE: Ž)
} SHRDATA, *PSHRDATA;

//  
#pragma data_seg("TRAYHK")
SHRDATA	g_ShrData = {NULL, NULL, 0};
#pragma data_seg()
#pragma comment(linker, "/SECTION:TRAYHK,rws")

HINSTANCE	g_hInst;		// DLL νϽ


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	g_hInst = (HINSTANCE) hModule;
    return TRUE;
}

//
// 콺  ν
//
// wheel ޽ ߻  hNotifyWnd uCallbackMsg 
//
LRESULT CALLBACK TrayMouseProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if(nCode >= 0)
	{
		if(g_ShrData.bHookPause == FALSE && wParam == WM_MOUSEWHEEL)
		{
			PMOUSEHOOKSTRUCT	pms = (PMOUSEHOOKSTRUCT) lParam;

			PostMessage(g_ShrData.hNotifyWnd, g_ShrData.uCallbackMsg, pms->dwExtraInfo, 0);
			return TRUE;
		}
	}

	return CallNextHookEx(g_ShrData.hHook, nCode, wParam, lParam);
}

//
//  ġ
//
// Ķ
//		hNotifyWnd		[in]	 
//		uCallbackMsg	[in]	ݹ ޽ ID
//
// ϰ
//		 쿡 1,   0 
//
TRAYHK_API
BOOL WINAPI InstallHook(HWND hNotifyWnd, UINT uCallbackMsg)
{
	BOOL	bRet = FALSE;

	if(g_ShrData.hHook == NULL)
	{
		g_ShrData.hNotifyWnd = hNotifyWnd;
		g_ShrData.uCallbackMsg = uCallbackMsg;
		g_ShrData.hHook = SetWindowsHookEx(WH_MOUSE, TrayMouseProc, g_hInst, 0);
		bRet = TRUE;
	}

	return bRet;
}

//
//  
//
// Ķ 
//
// ϰ
//		 쿡 1,  쿡 0 
//
TRAYHK_API
BOOL WINAPI RemoveHook()
{
	BOOL	bRet = FALSE;

	if(g_ShrData.hHook != NULL)
	{
		UnhookWindowsHookEx(g_ShrData.hHook);
		g_ShrData.hHook = NULL;
		bRet = TRUE;
	}

	return bRet;
}

//
//    
//
// ĸ 
//
// ϰ
//		 ̸ 0,  ¸ 1 
//
TRAYHK_API
BOOL WINAPI GetHookPause()
{
	return g_ShrData.bHookPause;
}

//
//   
//
// Ķ
//		bPause	[in]	Ż
//
// ϰ 
//
TRAYHK_API
VOID WINAPI SetHookPause(BOOL bPause)
{
	g_ShrData.bHookPause = bPause;
}